
#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <vector>

#include "libusb-1.0.8/libusb/libusb.h"

using namespace std;


class TascamUs1641 {

public:
	TascamUs1641();
	~TascamUs1641();

	void play();

private:

	bool returned;
	bool abort;
	bool controlTransferReturned;

	unsigned long int samplerate;

	libusb_device ** devs;
	libusb_device * dev;
	libusb_context * context;
	libusb_device_handle * handle;
	
	struct libusb_transfer * control_transfer;
	unsigned char * control_transfer_buffer;
	unsigned char * audio_in_buffer;
	unsigned char * audio_out_buffer;
	unsigned long int buffersize;

	struct libusb_transfer * transfer1;
	struct libusb_transfer * transfer2;
	struct libusb_transfer * transfer3;

	void reset_usb();
	void setup_usb();
	void release_usb();
	void resumePlayback();

	void submitAndWait_controlTransfer(uint8_t bmRequestType, uint8_t bRequest, uint16_t wValue, uint16_t wIndex, uint16_t wLength);
	void submit_controlTransfer(uint8_t bmRequestType, uint8_t bRequest, uint16_t wValue, uint16_t wIndex, uint16_t wLength);
	static void callback_controlTransfer(struct libusb_transfer * transfer);

	static void callback_audioout(struct libusb_transfer * transfer);
	static void callback_audioin(struct libusb_transfer * transfer);

	struct libusb_transfer * allocate_output_transfer();
	struct libusb_transfer * allocate_input_transfer();
};

